#lang scheme

(require
  scheme/foreign)

(unsafe!)

(define lib
  (ffi-lib "./my_lib"))

(define-struct my-type ((cptr #:mutable) (owned? #:mutable)))

(define (printo tag o)
  (printf "~a ~v~%" tag o)
  o)

(define-cpointer-type _my-type-ptr #f
 (lambda (v)
   (cond 
     ((my-type? v)
      (printo "s->c returning"
        (my-type-cptr (printo "s->c got" v))))
     ((my-type-ptr? v) v)
     (else
       (error "cannot coerce to _my-type-ptr"))))
 (lambda (ptr)
   (if ptr
     (let ((m (make-my-type ptr #t)))
       (register-finalizer m my-type-destroy)
       m)
     (error "got null"))))

(define my-type-maker
 (get-ffi-obj "my_type_maker" lib
   (_fun -> (ret : _my-type-ptr/null)
         -> (if ret ret (error "got null")))))

(define my-type-operation
 (get-ffi-obj "my_type_operation" lib
   (_fun _my-type-ptr -> _int)))

(define (my-type-destroy m)
  (let ((ptr (my-type-cptr m)))
    (when (and ptr (my-type-owned? m))
      (%my-type-destroy m)
      (set-my-type-cptr! m #f))))

(define %my-type-destroy
  (get-ffi-obj "my_type_destroy" lib
    (_fun _my-type-ptr -> _void)))



(define a (my-type-maker)) ; a is a proper my-type struct
(printf "a is ~v~%" a)

(printf "directly using ptr: ~v~%" (my-type-operation (my-type-cptr a)))

(my-type-operation a)      ; throws above error
